package net.javase.hksup.starter.model;

import com.alibaba.fastjson2.annotation.JSONField;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.util.List;

/**
 * UserInfo
 *
 * @author Frank
 */
@Getter
@Setter
@Builder
public class UserInfo implements Serializable {

    private String employeeNo;

    private String name;

    @Builder.Default
    private String userType = "normal";

    @Builder.Default
    @JSONField(name = "Valid")
    private Valid valid = new Valid();

    @Builder.Default
    private String doorRight = "1";

    @JSONField(name = "RightPlan")
    private List<RightPlan> rightPlan;

    @Builder.Default
    private String gender = "male";

    @Builder.Default
    private Boolean localUIRight = false;


    @Getter
    @Setter
    public static class Valid {
        private Boolean enable = true;

        private String beginTime = "2023-01-01T00:00:00";

        private String endTime = "2050-12-30T23:59:59";

        private String timeType = "local";

    }


    @Getter
    @Setter
    @AllArgsConstructor
    public static class RightPlan {

        private Integer doorNo;

        private String planTemplateNo = "1";

        public RightPlan(Integer doorNo) {
            this.doorNo = doorNo;
        }
    }

}
